//
//  StandardMoveComponent.m
//  SpaceInvadersTutorial
//
//  Created by Barbara Köhler on 6/14/13.
//  Copyright (c) 2013 Barbara Köhler. All rights reserved.
//

#import "StandardMoveComponent.h"

@interface StandardMoveComponent() {
    SKAction* moveAction;
    SKNode* movedNode;
}

@end

@implementation StandardMoveComponent

-(id) initMoveAction:(SKNode*) node withDuration:(float) moveDuration {
    self = [super init];
    if (self) {
        float distance = node.parent.frame.size.height + node.frame.size.height;
        SKAction* moveDown = [SKAction moveByX:0 y:-distance duration:moveDuration];
        SKAction* callBackAction = [SKAction performSelector:@selector(finishedMoving) onTarget:self];
        moveAction = [SKAction sequence: [NSArray arrayWithObjects:moveDown, callBackAction, nil]];
        movedNode = node;
    }
    return self;
}

-(void) finishedMoving {
    [movedNode removeAllActions];
    movedNode.position = CGPointMake(movedNode.position.x, movedNode.parent.frame.size.height + movedNode.frame.size.height/2);
}

-(void) move {
    [movedNode runAction:moveAction];
}

@end